unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    StaticText2: TStaticText;
    StaticText1: TStaticText;
    Button2: TButton;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var A,N,S : dword;

procedure showroot(a : dword);
//show a in statictext1
//a is dword with decimal point between bits 15,16
var al,ar : dword;
    b,i : byte;
    s : string;
begin
 al := a shr 16; //integer part
 ar := a and $ffff; //fraction part
 s := inttostr(al);
 if ar > 0 then
  begin
   s := s + decimalseparator;
   for i := 1 to 4 do
    begin
     ar := ar * 10 + 5; //round
     b := ar shr 16;
     ar := (ar and $ffff);
     s := s + chr(ord('0') + b);
    end;
  end;
 form1.StaticText1.Caption := s;
end;

procedure TForm1.Button1Click(Sender: TObject);
//calculate root, iterative way
var i : byte;
    R : dword; //result register, point in center
begin
 try
  N := strtoint(edit1.Text);
 except
  N := 1;
  edit1.Text := '1';
 end;  
 R := 0;
 A := 0;    //accumulator
 for i := 1 to 32 do       //root process
  begin
   A := (A shl 2) or (N shr 30);
   N := N shl 2;
   S := (R shl 2) or 1;    //subtract value
   R := R shl 1;
   if S <= A then begin
                   A := A - S;
                   R := R or 1;
                  end;
  end;
 showroot(R);
end;

function RecROOT(i : byte) : double;
//recursive root
begin
 if i >1 then result := A + S/(A + RecROOT(i-1))
  else result := A + S/(2*A);
end;

procedure TForm1.Button2Click(Sender: TObject);
//calculate root recursive way
var i,c  : byte;
    root : double;
begin
 try
  N := strtoint(edit1.text);
 except
  N := 1;
  edit1.Text := '1';
 end;
 c := 0;
 if N > 0 then
  begin
   for i := 0 to 31 do
    if ((1 shl i) and N) <> 0 then c := i;
   c := c shr 1;  //2 bit multiple
   A := 1 shl c;  //largest single bit root
   S := N - (A shl c);
   root := RecROOT(10);  //depth = 10
  end
  else root := 0;
 statictext2.Caption := FormatFloat('#0.0#####',root);
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
//character filter 
begin
 if not (key in ['0'..'9',#08]) then key := #0;
end;

end.
